\  Device.4th
\ -----------------------------------------------------------------------------
\  class Device               OOP Module for csp4th                  MM-060909
\ -----------------------------------------------------------------------------
\
\                     Copyright (C) 2008 Manfred Mahlow
\
\ This is Open Source Software released under the "Artistic License". See the
\ enclosed LICENSE file.
\ -----------------------------------------------------------------------------
 
  needs Cell
  needs String
  needs c api
 
  c api definitions

  \ Constants from /usr/include/asm-i386/unistd.h

     #5 constant __NR_open
     #6 constant __NR_close

  \ Constants from /usr/include/asm-i386/fcntl.h

     00 constant O_RDONLY
     01 constant O_WRONLY
     02 constant O_RDWR
  #4000 constant O_NONBLOCK

  oop definitions  c api
 
  class Device  Device definitions
 
  String this fname \ The full qualified file name of the device.
  Cell   this fd    \ The file descriptor of the device.
 
  self seal
 
  m: init (O c-addr u fd -- )
     this fd init  dup 5 + chars this fname init  this fname !
   ;

  m: ? (O -- )
     ." device=" this fname ?  ."  fd=" this fd ?
   ;
 
  m: close (O -- )
     this fd @ -1 = if ioerr off exit then 
     this fd @ 1 __NR_close syscall dup 0if -1 this fd ! then ioerr !
   ;
 
  m: open (O flags -- )
     this fd @ -1 >if drop ioerr off exit then
     this fname @z 2 __NR_open syscall dup -1 >if this fd ! 0 then ioerr !
   ;
 
  m: open/rn (O -- )
     O_RDONLY O_NONBLOCK or this open
   ;
 
  m: open/rwn (O -- )
     O_RDWR O_NONBLOCK or this open
   ;
 
  oop definitions
\ -----------------------------------------------------------------------------
\ Last revision: MM-080409 stack diagrams
\                MM-080224 path -> fname
\                MM-080216 ioctl moved to the core.

