\  help.4th
\ -----------------------------------------------------------------------------
\  help utility for csp4th                                           MM-080205
\ -----------------------------------------------------------------------------
\
\                   Copyright (C) 2008 Manfred Mahlow
\
\ This is Open Source Software released under the "Artistic License". See the
\ enclosed LICENSE file.
\ -----------------------------------------------------------------------------
\ This module must be loaded as the first one.

  loc:

  variable h.fd   h.fd off

  variable h.fp  h.fp off

  : h.item ( -- a ) scratch ;
  : h.scontext ( -- a ) h.item 255 + ;
  : h.buf ( -- ) h.scontext 255 + ;

  create a,u 2 cells allot   h.buf 1+ 0 a,u 2!

  s.context @ constant core-wordlist  

  : ((cn) ( cid -- a u )
  \ Return the name of the context 'cid'
    cell+ @ $FFFFFFFC and >name count ;   \ clear flags

  : (cn) ( cid -- a u )
  \ Return the name of the context cid. Return "forth" for the core-wordlist.
    dup core-wordlist =if drop "  forth" exit then
    0; dup %1 and 0if . exit then  \ print wordlist id and exit
       " " rot
       0 swap begin >r 1+ r@ #3 cells + @ dup 0until drop
              begin -rot r> ((cn) bl join rot 1- dup 0until drop ;

  : h.fname ( a1 u1 -- a2 u2 )
            " hlp" '. join  " help" 2swap 0 join bl2ps ;

0 [IF]
  : h? ( -- )
       cr ." help context : " h.scontext count '| emit type '| emit
       cr ." help file    : " h.scontext count h.fname type  ."   fd = " h.fd @ .
       cr ." help item    : " h.item count '| emit type '| emit
       cr ." help buffer  : " h.buf count swap . .
       cr ." a,u          : " a,u 2@ swap . .
       cr ." h.fp         : " h.fp @ .
   ;
[THEN]

  : h.open ( -- )
           h.scontext count h.fname 2dup /?/ open/r 
           dup 0 >if h.fd ! 2drop  h.fp off   0 h.buf c!  h.buf count a,u 2!
                  else drop cr ." Sorry, no help for" 
                       h.item count '\ skip 
                       dup 0if 2drop h.scontext count then type ."     "
                       type ."   Caught: -37" cr -37 throw
                  then ;

   : h.close ( -- ) h.fd @ close h.fd off ;

   : h.@buf ( -- u ) \ cr ."  @buf : " .s
            h.fp @ h.fd @ seek h.buf 1+ 255 h.fd @ read
            dup h.buf c!  h.buf count a,u 2! ;


   : h.@line ( -- a3 u3 -1 | 0 )
             begin
               \ cr  ." h.@line : " h.fp @ .
               a,u 2@ ( a1 u1 ) 10 split if
                  ( a2 u2 a1 u1' ) 2swap a,u 2! dup 1+ h.fp +! -1 exit
               else ( a1 u1 )
                 2drop h.@buf
               then
             0until 0 ;

   : h.text ( -- )
       begin
         h.@line 0if exit then
         dup if cr type -1 else 2drop 0 then
       0until ;

   : h.head ( -- -1|0 )
       begin
         h.@line 0if 0 exit then
         over h.item c@  h.item count 
         cmp 0if
           cr ."  Glossary: "  h.item count type
           h.scontext count "  Glossary" cmp
           if ."  in the context " h.scontext count type then
           cr cr type  -1 exit
         then
         2drop
      again ;

   : (h) ( -- )
       h.open
       h.item c@
       0if
         h.text cr
       else
         h.head  if
           h.text cr
         else
           cr  h.item count bl skip type ." ? not found  "
         then
       then
       h.close
    ;

   :: ( "name" -- )
      parsews dup 0if \ name=""
        2drop " " h.item place context @ (cn)
      else
        "  " h.item place  2dup h.item +place  bl h.item c+place 
        find if s.context @ (cn) else 2drop "  Glossary" then
      then
      h.scontext place (h) ;

   loc;

   : h ( "name" -- ) literal catch drop ;

\ -----------------------------------------------------------------------------
\  Last revision: MM-080530  Reva repeat while -> begin 0until
\                 MM-080226  No "\ " prefix for headers any more.

