\  tty.4th
\ -----------------------------------------------------------------------------
\  class tty               OOP Module for csp4th                     MM-080211
\ -----------------------------------------------------------------------------
\
\                    Copyright (C) 2008 Manfred Mahlow
\
\ This is Open Source Software released under the "Artistic License". See the
\ enclosed LICENSE file.
\ -----------------------------------------------------------------------------
  needs c api termios
  needs Device
  needs Cell
 
  c api definitions  decimal
 
  $540B constant TCFLSH    \ from /usr/include/asm-i386/ioctls.h 
 
  oop definitions  c api
 
  class tty  tty definitions  Device inherit

   termios this termios   \ buffer to manipulate the device termios

   termios this \termios  \ buffer to save and restore the device termios

  self seal

  m: write (O a u -- )
     this fd @ write
     \? ioerr @ ?dup if ."   " this path ? ."  : write error " . cr then
   ;

   m: tx (O c -- )
      sp@ 1 this write drop
   ;

  m: flush (O -- )
     2 TCFLSH 1 this fd @ ioctl drop
   ;
 
  m: read (O a u1 -- u2 )
     this fd @ read 0 max
     ioerr @ -11 = if ioerr off exit then
     \? ioerr @ ?dup 
     \? if ."   " this path ? ."  : read error " . cr then
   ;

  m: rx (O -- c true | false )
     0 sp@ 1 this read if true then ;
   ;

0 [IF]
  m: rx? (O -- u )
         0 sp@ FIONREAD 1 this fd @ ioctl
         \? if ."   " this path ? ."  read error " cr exit then
         drop
   ;
[THEN]

  m: ? (O -- )
     this ?
     this fd @ dup 0 < if drop exit then  pad termios @
     pad termios cflags ?
     pad termios iflags ?
     pad termios oflags ?
   ;

  forth definitions
 
  " stdout" stdout  tty new stdout   stdout init
 
  " stdin" stdin    tty new stdin   stdin init
 
  \? ."   'stdin' and 'stdout' are tty objects now. "
 
  oop definitions
\ -----------------------------------------------------------------------------
\  Last revision: MM-080409  stack diagrams

\  Note: You can use the command  stty -F /dev/ttySx -a   in a terminal to
\        display the parameters of /dev/ttySx.





