
include base.f
include if.f
include loc.f
include extra.f
include string.f
include loop.f
include misc.f
include preproc.f
| include func.f
include os.f       | words  time&date , ms , ms@ , getpid removed
                   | Windows broken   MM-060815
include fileio.f
include phrase.f   | new MM-060819
include pushpop.f  | new MM-060820
include needs.f

include patches.f  | new MM-071026


 : .ver ( -- ) ." csp4th for " osname type ;

 : .(c) ( -- ) ." .   Copyright (C) 2008 Manfred Mahlow.    " ;

 : .war ( -- ) ." This software comes " cr
               ." with absolutely no warranty, see the LICENSE file. "
               ." Type 'bye <enter>' to exit." ;


 1 variable, argc#
   variable  argcend

 : argv ( u1 -- c-addr u2 )  | MM-070525 
   dup argc 1- >if drop pad 0 exit then  | return pad 0 if arg# > argc-1
   0 max (argv) swap ?dup 0if zcount exit then 0 do zcount + 1+ loop zcount ;

loc:

 : 0dirs() ( -- ) | MM-080324
   | Init dir(1) with "appdir/user"
     appdir pad place 'ps pad c+place pad c@ >r " user" pad +place
     pad count 80 min dir(1) placez
   | Init dir(2) with "appdir/share"
     r> pad c! " share" pad +place  pad count 80 min dir(2) placez ;

: (?error) ( ? -- ) | error handling is here  |  MM-060819
         ?dup if src off tib off tib >in !    |  reset input
         0 prelude                            |  no prelude
         decimal
         ." Caught: " . cr [compile] [ then ; |  issue message  MM-070516

: ?error ( ? -- ) dup (?error) 0; ( drop ) reset ;      | MM-060819


 : ?rc ( -- ) | MM-080409
  | Try to include ~/.appnamerc
    " HOME" getenv " ." 'ps join  appname 0 join " rc" 0 join
    2dup open/r 0 <if 2drop exit else ['] (include) catch ?error then ;
|   ['] (include) catch ?error ;


: argv> argc# @ 1+ argv argc# ++ ;

 : e 2drop argv> evaluate ;
 : n 2drop argv> (needs) ;
 : t 2drop argv> (take) ;
 : v 2drop verbose on ;
 : X 2drop argc argc# ! ;

 : unknown  drop type ."  ? unknown option  " -1 throw ;

choices: args?
	' e 'e choice  | -e
	' n 'n choice  | -n
        ' t 't choice  | -t  
        ' v 'v choice  | -v
	' X '- choice  | --  end of parameter list
	' unknown default

: (hi) over count '- =if c@ args? else drop (include) then ;  

: argdo 1 argc# ! begin   | MM-070226 : 1 argc# !
    argc# @ argv (hi)
	argc# dup ++ @
	argc swap - 0 max 0until ;


 : hello ( -- )
   argc 1- 0if .ver .(c) .war cr exit then argdo ;

 :: ( -- )
    0dirs() ?rc
    ['] hello catch dup (?error) if -1 (bye) then
    begin ['] interp catch (?error) again
  ; is appstart  | MM-070516

 :: ( -- ) ."  ok" cr ; is prompt  | MM-070307

reveal ?error

loc; 

 hide .(c)  hide .ver  hide .war  | MM-070204

| Generate the Reva executable:
appdir pad place 
(os) [IF] " /csp4th" [ELSE] " \csp4th.exe" [THEN]
pad +place pad count (save) bye

| -----------------------------------------------------------------------------
| MM-070319  (?error) now resets the base to decimal
| MM-070510  ;; -> exit
| MM-070516  p: -> [compile]
|            error handling for options modified
| MM-070525  argv changed to return a string with a size of zero, for an index
|            >= argc.
| MM-070831  renamed to revaOE
| MM-071019  renamed to revaOE-n
| MM-071019  Appname renamed to csp4th
|            This file renamed to csp4th.f
| MM-080205  pathsep -> 'ps
| MM-080207  new: ?defs to read defaults.4th
| MM-080208  ?defs commented out because of bad error handling
| MM-080324  Initial loading of config file added.  0dirs() changed.
| MM-080530  Reva repeat -> begin , Reva while -> 0until
| MM-080815

