


  needs GtkHBox
  needs GtkVBox
  needs GtkComboBoxText
  needs GtkEntry
  needs GtkButton

  needs Array
  needs String

  oop definitions

  class NosqlGtkFilter  NosqlGtkFilter definitions  GtkHBox inherit

   GtkComboBoxText this items
   GtkComboBoxText this modes
   GtkEntry        this entry
   GtkButton       this button

   private

   String new pad  128 chars self pad init

   :: (O wid -- )
      drop " " this entry text ! ; 2 20 cb cb.clicked

   :: (O wid -- ) this entry is-focus on ; 2 20 cb cb.focus

   public

   m: init (O -- wid )
      this ( GtkHBox) init
      this items init  0 0 3 this pack_start
      " changed" this cb.focus swap this items signal connect drop
      this modes init  0 0 3 this pack_start
      " changed" this cb.focus swap this modes signal connect drop
      " " this entry init  -1 -1 3 this pack_start
      " gtk-clear" this button init  0 0 3 this pack_start
      " clicked" this cb.clicked swap this button signal connect drop
   ;
  
   m: @ (O -- a u )
      " " self pad !
      this entry text @ dup 0if exit then
      this items @ self pad !
      this modes @ " enthält" cmp 0if "  ~ " else "  !~ " then self pad +!
      " \"" self pad +! ( entry) self pad +! " \"" self pad +!
      self pad @ ;

   m: ? ( -- ) self @ type ;


   class Array  self Array definitions  Array inherit

     GtkVBox this vbox

     String new pad   128 chars self pad init

   m: init (O u -- )
           this vbox init swap
           dup this init
           0 do i this of init 0 0 3 this vbox pack_start loop ;

   m: @ (O -- a u )
       " '" self pad !
       0 this size 0 do
         i this of @ rot 0 >  over dup >r 0 > and if "  && " self pad +! then
         self pad +! r>
       loop
       drop " '" self pad +! self pad @
   ;

   m: +lplace ( a1 oid -- )
         self @ rot +lplace
   ;





  needs GtkToplevel
  needs GtkVBox
  needs GtkNotebook
  needs GtkScrolledWindow
  needs GtkTreeView
  needs GtkTreeViewColumn Array
  needs GtkListStore
  needs GtkCellRendererText
  needs GtkTreeIter

  needs c api
  needs String

\ ------------------------------------------------------------------------------
\  cspForth :  GtkTreeView for nosql                                  MM-080604
\ ------------------------------------------------------------------------------
\                      Copyright (C) 2008 Manfred Mahlow
\
\                      This code is in the public domain.
\ ------------------------------------------------------------------------------

  c api definitions

  libc import popen ( a.command a.type -- a.stream )
  libc import pclose ( a.stream -- n ) \ n = exit status of command
  libc import fgets ( a.buffer u a.stream -- n )

  gtk api definitions

  libgtk import gtk_tree_path_to_string ( *path -- *char )

  libgtk import g_free ( *char -- )


  GtkTreeView definitions

  private vocabulary example.1  self example.1 definitions  also gtk api

  GtkToplevel             new window
  GtkVBox                 new  vbox
  NosqlGtkFilter Array    new    filters
  NosqlGtkFilter          new    filter.1
  GtkButton               new     query.button
  NosqlGtkFilter          new    filter.2
  GtkNotebook             new    notebook
  GtkScrolledWindow       new     scrolled
  GtkTreeView             new      view
  GtkTreeViewColumn Array new      columns
  GtkVBox                 new     form
  GtkVBox                 new     edit

  GtkCellRendererText     new renderer
  GtkListStore            new list


  &001 constant 'SOH            \ ASCII SOH (Start Of Header)
   #09 constant 'TAB            \ ASCII TAB
   #10 constant 'NL             \ ASCII NEWLINE
  

  String new db-file  127 chars db-file init

  String new sorted    80 chars sorted init   
  String new cmdln    255 chars cmdln init  \ the command line for exec

  String new tcolumns  255 chars tcolumns init

  Cell new #cols  3 #cols init  \ number of table columns

  String new header  255 chars header init



   : get ( -- ? ) view selection @ 0if exit ." No item selected.  " -1 throw then
         list row ! 
         3 0 do i list value @ type space space loop drop ;


  :: ( wid data -- )   list free  gtk main_quit
  ;  2 20 cb cb.destroy

  :: ( wid.view path wid.column data -- )
     cr ." row activated on " >r rot . ." : "
     swap ." path=" dup . gtk_tree_path_to_string dup zcount type g_free
     ." , *column=" . r> ." , data=" .  cr get
   ; 4 20 cb cb.sel0

  :: ( wid data -- ) cr ." Column " . ." : wid=" . ; 2 20 cb cb.clicked

  defer 'query

  :: ( wid data -- ) 'query ; 2 40 cb cb.find


  : run ( -- )

      " NoSQL Table Viewer" window init
        6 window border-width !

      vbox init window add

      2 dup filters init  0 0 3 vbox pack_start
        0 do
             " ID,Attribut,Wert" ', i filters of items split
             0 i filters of items activate
             " enthält,enthält nicht" ', i filters of modes split
             0 i filters of modes activate
             " activate" cb.find 0 i filters of entry signal connect drop
        loop
        0 filters of entry is-focus yes

        " gtk-find" query.button init 0 0 3  0 filters of pack_start
          " clicked" cb.find 0 query.button signal connect drop

      notebook init -1 -1 6 vbox pack_start
        3 notebook border-width !

      scrolled init  " Listenansicht" notebook append
        300 scrolled width-request !
        250 scrolled height-request !

      form init " Formularansicht" notebook append
      edit init " Datensatz Editor" notebook append

      view init scrolled add
        6 scrolled border-width !
        view rules-hint on  0 view search-column !

      #cols @ columns init  renderer init
        dup " ID"        " text" 0  0 columns of init view append
        dup " Attribut"  " text" 1  1 columns of init view append
            " Wert"      " text" 2  2 columns of init view append

      #cols @ 0 do G_TYPE_STRING loop  #cols @ list init view model !
        #cols @ 0 do
          i columns of resizable on
          i columns of clickable yes
          " clicked" cb.clicked i 1+ i columns of signal connect drop
        loop

      " destroy" cb.destroy 0 window signal connect drop

      " row-activated" cb.sel0 0 view signal connect drop

      window show_all

   ;


   also c api

   Cell new row    0 row init
   Cell new col    0 col init


   : approw ( a -- flag ) \ append the zero terminated string at a to the list
       0 col !
       dup c@ 'SOH <>if
         zcount 'NL -skip
         list append
         begin 'TAB split >r "" col @ list text ! col inc r> 0until
         row inc
       else
         drop
       then false ;


   : ztype ( a -- ) zcount type ;


\ Execute a command and execute the word with xt on every zero terminated
\ line of the command output.  xt ( a -- )


   : (exec) ( i*x xt a u -- j*x )
        zt " r" zt popen ?dup 0if ." popen failed " -1 throw then >r >r
        begin pad 1000 1 rpick fgets while
          pad zcount + 1- c@ 'NL <>if
            cr ." Error: Line Buffer Overflow " -1 throw
          then
          pad r@ execute if r> ( xt ) drop r> pclose drop exit then
        repeat
        r> ( xt ) drop r> pclose drop ;


   : exec ( i*x xt <command> -- j*x )
        phrase (exec) ;

   : select ( <command> -- )
        list clear  0 row !  ['] approw exec ;
        
  " ~/Daten/nosql/Kontakte-neu.rdb" db-file !

  " ID " sorted !

  : query ( -- )
      list clear
      " cat " pad lplace  db-file @ pad +lplace
      " | nosql row " pad +lplace  pad filters +lplace
      "  | nosql sort " pad +lplace  sorted @ pad +lplace
      ( list clear ) 0 row !  ['] approw pad lcount (exec)
  ;


  : head ( a -- )
         " " tcolumns !
         zcount 'SOH skip 'NL -skip
         begin 'SOH split >r tcolumns +! r> 0until 
         tcolumns ? ;


  : !header ( a -- a1 u1 )
            dup c@ 'SOH =if
              zcount 'NL -skip header ! true
            else
              drop false
            then
            ;

  : get-header ( -- )
      " " header !
      " head -n 1 " pad place db-file @ pad +place 
      ['] !header pad count (exec)
      header @ ;
      


  ' query is 'query

   hide cb.sel0  hide cb.clicked  hide cb.destroy

   previous previous

   run term? [IF] ?? [ELSE] gtk main bye [THEN]

\ ------------------------------------------------------------------------------
\ MM-080604
